<?php

/* vim: set expandtab tabstop=4 softtabstop=4 shiftwidth=4:
  CodOBificación: UTF-8
  +----------------------------------------------------------------------+
  | Elastix version 2.4.0-1                                              |
  | http://www.elastix.org                                               |
  +----------------------------------------------------------------------+
  | Copyright (c) 2006 Palosanto Solutions S. A.                         |
  +----------------------------------------------------------------------+
  | Cdla. Nueva Kennedy Calle E 222 y 9na. Este                          |
  | Telfs. 2283-268, 2294-440, 2284-356                                  |
  | Guayaquil - Ecuador                                                  |
  | http://www.palosanto.com                                             |
  +----------------------------------------------------------------------+
  | The contents of this file are subject to the General Public License  |
  | (GPL) Version 2 (the "License"); you may not use this file except in |
  | compliance with the License. You may obtain a copy of the License at |
  | http://www.opensource.org/licenses/gpl-license.php                   |
  |                                                                      |
  | Software distributed under the License is distributed on an "AS IS"  |
  | basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See  |
  | the License for the specific language governing rights and           |
  | limitations under the License.                                       |
  +----------------------------------------------------------------------+
  | The Original Code is: Elastix Open Source.                           |
  | The Initial Developer of the Original Code is PaloSanto Solutions    |
  +----------------------------------------------------------------------+
  $Id: index.php,v 1.1 2013-06-10 07:10:30 Nikita Rukavkov admin@voip-lab.ru Exp $ */

function _moduleContent(&$smarty, $module_name)
{

    foreach($_POST as $key=>$val){
        $val = preg_replace("/<.*?>/","",$val);
        $_POST[$key] = $val;
    }

    include_once "libs/paloSantoForm.class.php";
    include_once "libs/paloSantoGrid.class.php";
    include_once "libs/paloSantoConfig.class.php";
    include_once "libs/paloSantoNetwork.class.php";
    
    include_once "modules/$module_name/configs/default.conf.php";
    include_once "modules/$module_name/libs/paloSantoOpenVPN.class.php";
    
    global $arrConf;
    global $arrLang;
    global $arrLangModule;
    
    
    $lang=get_language();
    $lang_file="modules/$module_name/lang/$lang.lang";
    $lic_file="modules/$module_name/configs/openvpn.lic";
    
    $base_dir=dirname($_SERVER['SCRIPT_FILENAME']); 
    
    $pNet = new paloNetwork();
    
    $pDB = new paloDB($arrConfig['dsn_conn_database']);
    
    if (file_exists("$base_dir/$lang_file")) include_once "$lang_file";
    else include_once "modules/$module_name/lang/en.lang";    
    
    $paloOpenVPN = new PaloSantoOpenVPN($pDB);    
    
    $arrLang = array_merge($arrLang,$arrLangModule);
    
    $base_dir=dirname($_SERVER['SCRIPT_FILENAME']);
    $templates_dir=(isset($arrConfig['templates_dir']))?$arrConfig['templates_dir']:'themes';
    $local_templates_dir="$base_dir/modules/$module_name/".$templates_dir.'/'.$arrConf['theme'];

    $arrNetTools = array(
			"pa_local"   => array(  "LABEL"                     => $arrLang["Listen"],
                                                "REQUIRED"                  => "yes",
                                                "INPUT_TYPE"                => "SELECT",
                                                "VALIDATION_TYPE"           => "",
						"INPUT_EXTRA_PARAM"	    => $paloOpenVPN->getInterfacesOpenVPN($pNet->obtener_interfases_red()),
                                                "VALIDATION_EXTRA_PARAM"    => ""),

			"pa_port"   => array(   "LABEL"                     => $arrLang["Port"],
                                                "REQUIRED"                  => "yes",
                                                "INPUT_TYPE"                => "TEXT",
                                                "VALIDATION_TYPE"           => "numeric",
						"INPUT_EXTRA_PARAM"	    => array('size'=>'25'),
                                                "VALIDATION_EXTRA_PARAM"    => ""),

			"pa_proto"   => array(   "LABEL"                    => $arrLang["Protocol"],
                                                "REQUIRED"                  => "yes",
                                                "INPUT_TYPE"                => "SELECT",
                                                "VALIDATION_TYPE"           => "",
						"INPUT_EXTRA_PARAM"	    => array("udp" => "udp","tcp" => "tcp"),
                                                "VALIDATION_EXTRA_PARAM"    => ""),

			"pa_server_network"   => array( "LABEL"             => $arrLang["OpenVPN Network"],
                                                "REQUIRED"                  => "yes",
                                                "INPUT_TYPE"                => "TEXT",
                                                "VALIDATION_TYPE"           => "",
						"INPUT_EXTRA_PARAM"	    => array('size'=>'25'),
                                                "VALIDATION_EXTRA_PARAM"    => ""),


			"pa_dns1"   => array(   "LABEL"               	    => $arrLang["Primary DNS"],
                                                "REQUIRED"                  => "no",
                                                "INPUT_TYPE"                => "TEXT",
                                                "VALIDATION_TYPE"           => "ip",
						"INPUT_EXTRA_PARAM"	    => array('size'=>'25'),
                                                "VALIDATION_EXTRA_PARAM"    => ""),

			"pa_dns2"   => array(   "LABEL"              	    => $arrLang["Secondary DNS"],
                                                "REQUIRED"                  => "no",
                                                "INPUT_TYPE"                => "TEXT",
                                                "VALIDATION_TYPE"           => "ip",
						"INPUT_EXTRA_PARAM"	    => array('size'=>'25'),
                                                "VALIDATION_EXTRA_PARAM"    => ""),

			"pa_maxclients"   => array("LABEL"                  => $arrLang["Maximum Clients"],
                                                "REQUIRED"                  => "yes",
                                                "INPUT_TYPE"                => "TEXT",
                                                "VALIDATION_TYPE"           => "numeric",
						"INPUT_EXTRA_PARAM"	    => array('size'=>'25'),
                                                "VALIDATION_EXTRA_PARAM"    => ""),

			"pa_ping"   => array("LABEL"              	    => $arrLang["Ping"],
                                                "REQUIRED"                  => "yes",
                                                "INPUT_TYPE"                => "TEXT",
                                                "VALIDATION_TYPE"           => "numeric",
						"INPUT_EXTRA_PARAM"	    => "",
						"INPUT_EXTRA_PARAM"	    => array('style'=>'width:30px'),
                                                "VALIDATION_EXTRA_PARAM"    => ""),

			"pa_ping_restart"   => array("LABEL"                => $arrLang["Ping Restart"],
                                                "REQUIRED"                  => "yes",
                                                "INPUT_TYPE"                => "TEXT",
                                                "VALIDATION_TYPE"           => "numeric",
						"INPUT_EXTRA_PARAM"	    => array('style'=>'width:30px'),
                                                "VALIDATION_EXTRA_PARAM"    => ""),

			"pa_verbose"   => array("LABEL"                     => $arrLang["Log Level"],
                                                "REQUIRED"                  => "yes",
                                                "INPUT_TYPE"                => "SELECT",
                                                "VALIDATION_TYPE"           => "",
						"INPUT_EXTRA_PARAM"	    => array(	"0"=>"0",
											"1"=>"1",
											"2"=>"2",
											"3"=>"3",
											"4"=>"4",
											"5"=>"5",
											"6"=>"6",
											"7"=>"7",
											"8"=>"8",
											"9"=>"9",
										),
											
                                                "VALIDATION_EXTRA_PARAM"    => ""),

                         "lic_file"              => array( "LABEL" => $arrLang["License file"],
                        			"REQUIRED" => "no",
                        			"INPUT_TYPE" => "FILE",
                        			"INPUT_EXTRA_PARAM" => "",
                        			"VALIDATION_TYPE" => "filename",
                        			"VALIDATION_EXTRA_PARAM" => ""),


			"pa_redirect_gw"   => array(   "LABEL"              => $arrLang["Default Gateway"],
                                                "REQUIRED"                  => "yes",
                                                "INPUT_TYPE"                => "CHECKBOX",
                                                "VALIDATION_TYPE"           => "",
						"INPUT_EXTRA_PARAM"	    => "",
                                                "VALIDATION_EXTRA_PARAM"    => ""),

			"pa_serveronly"   => array("LABEL"              => $arrLang["Invisible Clients"],
                                                "REQUIRED"                  => "yes",
                                                "INPUT_TYPE"                => "CHECKBOX",
                                                "VALIDATION_TYPE"           => "",
						"INPUT_EXTRA_PARAM"	    => "",
                                                "VALIDATION_EXTRA_PARAM"    => ""),

			"pa_compr"   => array("LABEL"              => $arrLang["Enable Compression"],
                                                "REQUIRED"                  => "yes",
                                                "INPUT_TYPE"                => "CHECKBOX",
                                                "VALIDATION_TYPE"           => "",
						"INPUT_EXTRA_PARAM"	    => "",
                                                "VALIDATION_EXTRA_PARAM"    => ""),

			"use_hostname"   => array(   "LABEL"              => $arrLang["Use Hostname"],
                                                "REQUIRED"                  => "yes",
                                                "INPUT_TYPE"                => "CHECKBOX",
                                                "VALIDATION_TYPE"           => "",
						"INPUT_EXTRA_PARAM"	    => "",
                                                "VALIDATION_EXTRA_PARAM"    => ""),

			"enable_nat"   => array(   "LABEL"              => $arrLang["Enable NAT"],
                                                "REQUIRED"                  => "yes",
                                                "INPUT_TYPE"                => "CHECKBOX",
                                                "VALIDATION_TYPE"           => "",
						"INPUT_EXTRA_PARAM"	    => "",
                                                "VALIDATION_EXTRA_PARAM"    => ""),
                        "static_routes"   => array(   "LABEL"              => $arrLang["Static Routes"],
                                                "REQUIRED"                  => "no",
                                                "INPUT_TYPE"                => "TEXTAREA",
                                                "VALIDATION_TYPE"           => "",
						"INPUT_EXTRA_PARAM"	    => array('style'=>'width:98%'),
                                                "VALIDATION_EXTRA_PARAM"    => ""),
                        


                        );

    //SUBMIT ADD NEW USER
    if(isset($_POST['add_new_user']))
    {
	$arrFillUser = array();
        foreach(array('common_name','country','city','province','city','organization','email','cn','static_ip','expdate') as $v) 
	    if(isset($_POST[$v])) {
	        $space_filter = str_replace(' ','',$_POST[$v]);
	        $space_filter = preg_replace('/\s/', '', $space_filter);
	        $arrFillUser[$v] = $space_filter;
	        $$v = $space_filter;
	    }
	include_once("libs/paloSantoForm.class.php");
	$oForm = new paloForm($smarty, createNewUserForm($arrLang,$paloOpenVPN));

        $smarty->assign("CANCEL", $arrLang["Cancel"]);
        $smarty->assign("ADD_NEW_USER", $arrLang["Save user"]);
        $smarty->assign("icon",'modules/openvpn_server/images/openvpn_logo.png');
        
        if(!$paloOpenVPN->validate('alphanum',$arrFillUser['common_name']))
        {
    	    $smarty->assign("mb_title", _tr('Validation Error'));
	    $smarty->assign("mb_message", _tr('ALPHANUM_ERROR'));
	    $contenidoModulo=$oForm->fetchForm("$local_templates_dir/new_user.tpl", $arrLang["Add New User"],$arrFillUser);
	    return $contenidoModulo;
        }
	elseif(!$oForm->validateForm($_POST))
	{
	    $arrErrores = $oForm->arrErroresValidacion;
	    $strErrorMsg = "<b>"._tr("The following fields contain errors").":</b><br/>";
	    if(is_array($arrErrores) && count($arrErrores) > 0){
		foreach($arrErrores as $k=>$v)
		    $strErrorMsg .= "$k, ";
	    }
	    $smarty->assign("mb_message", $strErrorMsg);
	    $contenidoModulo=$oForm->fetchForm("$local_templates_dir/new_user.tpl", $arrLang["Add New User"],$arrFillUser);
	    return $contenidoModulo;
	}
	elseif(strtotime($arrFillUser['expdate']) - strtotime(date("d.m.Y"))<=0)
        {
    	    $smarty->assign("mb_title", _tr('Validation Error'));
	    $smarty->assign("mb_message", _tr('CALENDAR_ERROR'));
	    $contenidoModulo=$oForm->fetchForm("$local_templates_dir/new_user.tpl", $arrLang["Add New User"],$arrFillUser);
	    return $contenidoModulo;
        }

	else
	{
	    if(!$paloOpenVPN->addUserOpenVPN($arrFillUser))
	    {
	    	$smarty->assign("mb_title", _tr("Unregistered Version"));
		$smarty->assign("mb_message", _tr($paloOpenVPN->errMsg));

		$contenidoModulo=$oForm->fetchForm("$local_templates_dir/new_user.tpl", $arrLang["Add New User"],$arrFillUser);
		return $contenidoModulo;
	    }
	    else
	    {
	    	$smarty->assign("mb_title", _tr("User added"));
		$smarty->assign("mb_message", _tr("The user $arrFillUser[common_name] was successfully created!"));
	    }
	}
    }
    else if(isset($_POST['save_edit_user']))
    {
	$arrFillUser = array();
        foreach(array('common_name','static_ip') as $v) 
	    if(isset($_POST[$v])) {
	        $space_filter = str_replace(' ','',$_POST[$v]);
	        $space_filter = preg_replace('/\s/', '', $space_filter);
	        $arrFillUser[$v] = $space_filter;
	        $$v = $space_filter;
	    }

	include_once("libs/paloSantoForm.class.php");
	$oForm = new paloForm($smarty, createEditUserForm($arrLang,$paloOpenVPN));

        $smarty->assign("CANCEL", $arrLang["Cancel"]);
        $smarty->assign("ADD_NEW_USER", $arrLang["Save user"]);
        $smarty->assign("icon",'modules/openvpn_server/images/openvpn_logo.png');
        $smarty->assign("confirm_message", $arrLang["WARNING_EDITUSER"]);
        
	if(!$oForm->validateForm($_POST))
	{
	    $arrErrores = $oForm->arrErroresValidacion;
	    $strErrorMsg = "<b>"._tr("The following fields contain errors").":</b><br/>";
	    if(is_array($arrErrores) && count($arrErrores) > 0){
		foreach($arrErrores as $k=>$v)
		    $strErrorMsg .= "$k, ";
	    }
	    $smarty->assign("mb_message", $strErrorMsg);

	    
	    
	    $contenidoModulo=$oForm->fetchForm("$local_templates_dir/edit_user.tpl", $arrLang["Edit User"],$arrFillUser);
	    return $contenidoModulo;
	}
	else
	{
	    if(!$paloOpenVPN->editUserOpenVPN($arrFillUser))
	    {
	    	$smarty->assign("mb_title", _tr("Validation Error"));
		$smarty->assign("mb_message", _tr("Edit user error!"));

		$contenidoModulo=$oForm->fetchForm("$local_templates_dir/edit_user.tpl", $arrLang["Edit User"],$arrFillUser);
		return $contenidoModulo;
	    }
	    else
	    {
	    	$smarty->assign("mb_title", _tr("User edited"));
		$smarty->assign("mb_message", _tr("The user $arrFillUser[common_name] was successfully edited!"));
	    }
	}
    }
    

    //ADD NEW USER FORM
    else if(isset($_POST['adduser']))
    {
    	include_once("libs/paloSantoForm.class.php");
    	
    	if(!file_exists('/etc/openvpn/server.crt') || !file_exists('/etc/openvpn/server.key'))
    	{
    	    $smarty->assign("mb_title", $arrLang['ADD_USER_ERR']);
	    $smarty->assign("mb_message", $arrLang['CERT_ERR']);
    	}
    	elseif(!file_exists('/etc/openvpn/server.conf'))
	{
	    $smarty->assign("mb_title", $arrLang['ADD_USER_ERR']);
	    $smarty->assign("mb_message", $arrLang['SETTINGS_ERR']);
	}	
    	else
    	{
	    $oForm = new paloForm($smarty, createNewUserForm($arrLang,$paloOpenVPN));
	
	    $smarty->assign("CANCEL", $arrLang["Cancel"]);
	    $smarty->assign("ADD_NEW_USER", $arrLang["Save user"]);
	    $smarty->assign("icon",'modules/openvpn_server/images/openvpn_logo.png');
	
	    $arrFillUser['country']=$paloOpenVPN->loadExportVars("KEY_COUNTRY");
	    $arrFillUser['province']=$paloOpenVPN->loadExportVars("KEY_PROVINCE");
	    $arrFillUser['city']=$paloOpenVPN->loadExportVars("KEY_CITY");
	    $arrFillUser['organization']=$paloOpenVPN->loadExportVars("KEY_ORG");
	    $arrFillUser['cn']=$paloOpenVPN->loadExportVars("KEY_CN");

	    $contenidoModulo=$oForm->fetchForm("$local_templates_dir/new_user.tpl", $arrLang["Add New User"],$arrFillUser);
	    return $contenidoModulo;
	}
    }
    else if(isset($_POST['add_new_server']))
    {
        
	$arrValues = array();
        foreach(array('country','city','province','city','organization','email','cn') as $v) 
	    if(isset($_POST[$v])) {
	        $space_filter = str_replace(' ','',$_POST[$v]);
	        $space_filter = preg_replace('/\s/', '', $space_filter);
	        $arrValues[$v] = $space_filter;
	        $$v = $space_filter;
	    }
	include_once("libs/paloSantoForm.class.php");
	$oForm = new paloForm($smarty, createNewServerForm($arrLang,$paloOpenVPN));

	$smarty->assign("confirm_message", $arrLang["WARNING_NEWSERVER"]);
	if(!$oForm->validateForm($_POST))
	{
	    $smarty->assign("mb_title", _tr("Validation Error"));
	    $arrErrores = $oForm->arrErroresValidacion;
	    $strErrorMsg = "<b>"._tr("The following fields contain errors").":</b><br/>";
	    if(is_array($arrErrores) && count($arrErrores) > 0){
		foreach($arrErrores as $k=>$v)
		    $strErrorMsg .= "$k, ";
	    }
	    $smarty->assign("mb_message", $strErrorMsg);

	    $smarty->assign("CANCEL", $arrLang["Cancel"]);
	    $smarty->assign("SAVE_SERVER_CFG", $arrLang["Save config"]);
	    $smarty->assign("icon",'modules/openvpn_server/images/openvpn_logo.png');
	    
	    $contenidoModulo=$oForm->fetchForm("$local_templates_dir/newserver.tpl", $arrLang["Server config"],$arrValues);
	    return $contenidoModulo;
	}
	else
	{
	    if($paloOpenVPN->addServerOpenVPN($arrValues))
	    {
		$smarty->assign("mb_title", _tr("SERVER_CERTIFICATES_SUCCESS"));
		$smarty->assign("mb_message", _tr("SERVER_CERTIFICATES_SUCCESS_DETAILS"));
	    }
	    else
	    {
		$smarty->assign("mb_title", _tr("SERVER_CERTIFICATES_ERROR"));
		$smarty->assign("mb_message", _tr("SERVER_CERTIFICATES_ERROR_DETAILS"));
	    }
	    
	    $arrValues=$paloOpenVPN->loadSettings();
	}
    }
    
    else if(isset($_POST['server_cfg']))
    {
    
    	include_once("libs/paloSantoForm.class.php");
	$oForm = new paloForm($smarty, createNewServerForm($arrLang,$paloOpenVPN));
	
	
	$smarty->assign("CANCEL", $arrLang["Cancel"]);
	$smarty->assign("SAVE_SERVER_CFG", $arrLang["Save config"]);
	$smarty->assign("icon",'modules/openvpn_server/images/openvpn_logo.png');
	$smarty->assign("confirm_message", $arrLang["WARNING_NEWSERVER"]);
	
	$arrFillUser['country']=$paloOpenVPN->loadExportVars("KEY_COUNTRY");
	$arrFillUser['province']=$paloOpenVPN->loadExportVars("KEY_PROVINCE");
	$arrFillUser['city']=$paloOpenVPN->loadExportVars("KEY_CITY");
	$arrFillUser['organization']=$paloOpenVPN->loadExportVars("KEY_ORG");
	$arrFillUser['cn']=$paloOpenVPN->loadExportVars("KEY_CN");
	$arrFillUser['email']=$paloOpenVPN->loadExportVars("KEY_EMAIL");
	
	$contenidoModulo=$oForm->fetchForm("$local_templates_dir/newserver.tpl", $arrLang["Server config"],$arrFillUser);
	return $contenidoModulo;
    }

    elseif(isset($_POST['mail_cfg']))
    {
    
    	include_once("libs/paloSantoForm.class.php");
	$oForm = new paloForm($smarty, createMailTemplateForm($arrLang));
	
	$smarty->assign("CANCEL", $arrLang["Cancel"]);
	$smarty->assign("SAVE_MAIL_TEMPLATE", $arrLang["Save template"]);
	$smarty->assign("icon",'modules/openvpn_server/images/openvpn_logo.png');
	
	$arrFillUser['subject']=$paloOpenVPN->loadMailTemplate("SUBJECT");
	$arrFillUser['realname']=$paloOpenVPN->loadMailTemplate("REALNAME");
	$arrFillUser['body']=$paloOpenVPN->loadMailTemplate("BODY");
	$arrFillUser['from_mail']=$paloOpenVPN->loadMailTemplate("FROM_MAIL");
	
	if($arrFillUser['from_mail']=='') 
	{
	    $pNet = new paloNetwork();
	    $pNetConfig = $pNet->obtener_configuracion_red();
	    $arrFillUser['from_mail'] = 'elastix@'.$pNetConfig['host'];
	}
	
	$contenidoModulo=$oForm->fetchForm("$local_templates_dir/mailtemplate.tpl", $arrLang["Mail Template"],$arrFillUser);
	
	return $contenidoModulo;
    }
    
    elseif(isset($_POST['save_mail_template']))
    {
        
	$arrValues = array();
        foreach(array('subject','body','realname','from_mail') as $v) 
	    if(isset($_POST[$v])) {
		$arrValues[$v]=$_POST[$v];
	    }
	    
	include_once("libs/paloSantoForm.class.php");
	$oForm = new paloForm($smarty, createMailTemplateForm($arrLang));

	if(!$oForm->validateForm($_POST))
	{
	    $smarty->assign("mb_title", _tr("Validation Error"));
	    $arrErrores = $oForm->arrErroresValidacion;
	    $strErrorMsg = "<b>"._tr("The following fields contain errors").":</b><br/>";
	    if(is_array($arrErrores) && count($arrErrores) > 0){
		foreach($arrErrores as $k=>$v)
		    $strErrorMsg .= "$k, ";
	    }
	    $smarty->assign("mb_message", $strErrorMsg);

	    $smarty->assign("CANCEL", $arrLang["Cancel"]);
	    $smarty->assign("SAVE_MAIL_TEMPLATE", $arrLang["Save template"]);

	    $smarty->assign("icon",'modules/openvpn_server/images/openvpn_logo.png');
	    
	    $contenidoModulo=$oForm->fetchForm("$local_templates_dir/mailtemplate.tpl", $arrLang["Mail Template"],$arrValues);
	    return $contenidoModulo;
	}
	else
	{
	    if(!$paloOpenVPN->saveMailTemplateOpenVPN($arrValues))
	    {
	    	$smarty->assign("mb_title", $arrLang["Mail Template"]);
		$smarty->assign("mb_message", $arrLang["Template Error"]);
	    }
	    else
	    {
	    	$smarty->assign("mb_title", $arrLang["Mail Template"]);
		$smarty->assign("mb_message", $arrLang["Mail Template Saved"]);
	    }
	    $arrValues=$paloOpenVPN->loadSettings();
	}
    }

    else if(isset($_GET['edit_user']))
    {
    
    	include_once("libs/paloSantoForm.class.php");
    	$smarty->assign("confirm_message", $arrLang["WARNING_EDITUSER"]);
	$oForm = new paloForm($smarty, createEditUserForm($arrLang,$paloOpenVPN,getParameter('common_name')));
	
	$smarty->assign("CANCEL", $arrLang["Cancel"]);
	$smarty->assign("ADD_NEW_USER", $arrLang["Save user"]);
	$smarty->assign("icon",'modules/openvpn_server/images/openvpn_logo.png');
	
	$arrFillUser['common_name'] = getParameter('common_name');
	$arrFillUser['static_ip'] = $paloOpenVPN->getStaticIpListOpenVPN(getParameter('static_ip'),getParameter('common_name'));
	
	$contenidoModulo=$oForm->fetchForm("$local_templates_dir/edit_user.tpl", $arrLang["Edit User"],$arrFillUser);
	return $contenidoModulo;
    }

    $oForm = new paloForm($smarty, $arrNetTools);
    
    $filter_common_name = getParameter('filter_common_name');
    $filter_email = getParameter('filter_email');
    $filter_real_ip = getParameter('filter_real_ip');
    $filter_virtual_ip = getParameter('filter_virtual_ip');
    

    $smarty->assign("Filter", $arrLang["Filter"]);
    $smarty->assign("Additional_Options", $arrLang["Additional Options"]);
    $smarty->assign("Keep_Alive_Options", $arrLang["Keep Alive Options"]);
    $smarty->assign("Download_Logs", $arrLang["Download Logs"]);
    
    $arrFormElements = createFilterForm($arrLang);
    
    
    $oFilterForm = new paloForm($smarty,$arrFormElements);


    /*
	'pa_local',
	'pa_port',
	'pa_proto',
	'pa_server_network',
	'pa_dns1',
	'pa_dns2',
	'pa_redirect_gw',
	'pa_serveronly',
	'pa_compr',
	'pa_maxclients',
	'pa_verbose'
    */
    if(getParameter("update")) {
        $arrValues = array();
        foreach(array('pa_local','pa_port','pa_proto','pa_server_network','pa_dns1','pa_dns2','pa_redirect_gw','pa_serveronly','pa_compr','pa_maxclients','pa_verbose','pa_ping','pa_ping_restart','use_hostname','enable_nat','static_routes') as $v) 
	    if(isset($_POST[$v])) {
	        //В static_routes фильтрация не нужна
	        if($v == 'static_routes')
	        {
	    	    $arrValues[$v]='';
	    	    $arrRoutes=split("\n",$_POST[$v]);
	    	    
	    	    foreach($arrRoutes as $route)
	    	    {
	    		$route = preg_replace('/\s/', '', str_replace(' ','',$route));
	    		if($route != '') $arrValues[$v].= $route.',';
	    	    }
		}
	    	else
	    	{
	    	    $space_filter = str_replace(' ','',$_POST[$v]);
	    	    $space_filter = preg_replace('/\s/', '', $space_filter);
	    	    $arrValues[$v]=$space_filter;
	    	}
	        $$v = $space_filter;
	    }
        if($_FILES["lic_file"]["error"]<=0)
        {
	    if ($paloOpenVPN->moveLicense($_FILES['lic_file']['tmp_name']))
	    {
		$smarty->assign("mb_title", $arrLang["License file"]);
		$smarty->assign("mb_message", "License file successfully uploaded");
	    }
	    else
	    {
		$smarty->assign("mb_title", $arrLang["License file"]);
		$smarty->assign("mb_message", "Error file upload license. please contact support.");
	    }
	}

	if(!$oForm->validateForm($_POST)){
	    $smarty->assign("mb_title", _tr("Validation Error"));
	    $arrErrores = $oForm->arrErroresValidacion;
	    $strErrorMsg = "<b>"._tr("The following fields contain errors").":</b><br/>";
	    if(is_array($arrErrores) && count($arrErrores) > 0){
		foreach($arrErrores as $k=>$v)
		    $strErrorMsg .= "$k, ";
	    }
	    $smarty->assign("mb_message", $strErrorMsg);
	} 
	elseif(getParameter('pa_ping_restart')<=getParameter('pa_ping') || round(getParameter('pa_ping_restart')/getParameter('pa_ping')<2))
	{
	    $smarty->assign("mb_title", _tr("Validation Error"));
	    $strErrorMsg = _tr("Options error: the second parameter to Restart After must be at least twice the value of the first parameter Ping Every. A ratio of 1:5 or 1:6 would be even better. Recommended setting is 10 60.")."<br/>";
	    $smarty->assign("mb_message", $strErrorMsg);
	}
	elseif(!$paloOpenVPN->validate('ip/mask',getParameter('pa_server_network')))
	{
	    $smarty->assign("mb_title", _tr("Validation Error"));
	    $strErrorMsg = "<b>"._tr("The following fields contain errors:")."</b><br/> OpenVPN Network must be formatted like xxx.xxx.xxx.xxx/yyy.yyy.yyy.yyy.";
	    $smarty->assign("mb_message", $strErrorMsg);
	}
	elseif(!$paloOpenVPN->validate('ip/mask_array',array_filter(split(',',$arrValues['static_routes']))))
	{
	    $smarty->assign("mb_title", _tr("Validation Error"));
	    $strErrorMsg = "<b>"._tr("The following fields contain errors:")."</b><br/> Static Routes must be formatted like<br />xxx.xxx.xxx.xxx/yyy.yyy.yyy.yyy<br />xxx.xxx.xxx.xxx/yyy.yyy.yyy.yyy";
	    $smarty->assign("mb_message", $strErrorMsg);
	    
	}
	else{
//	    if(!isset($arrValues['static_routes'])) $arrValues['static_routes'] = '';
	    //TRIAL LIMITS
	    if($paloOpenVPN->checkLic()!=0)
	    {
		//Дефолтные параметры для TRIAL версии
		$arrValues['pa_server_network'] = '192.168.10.0/255.255.255.0';
		$arrValues['pa_port'] = '1195';
		$arrValues['static_routes'] = '';
	    }
	    if(!$paloOpenVPN->updateFileConfOpenVPN($arrValues))
	    {
		 $smarty->assign("mb_title", $arrLang["Save settings error"].":");
		 $smarty->assign("mb_message", $paloOpenVPN->errMsg);
	    }
	    else
	    {
	    	 $smarty->assign("mb_title", $arrLang["OpenVPN Settings"]);
		 $smarty->assign("mb_message", $arrLang["OpenVPN Server Settings saved successfully"]);
		 $arrValues=$paloOpenVPN->loadSettings();
	    }
	}
	$arrValues['static_routes'] = str_replace(",","\n",$arrValues['static_routes']);
    }
    
    if(getParameter('stop')) {
	   if(!$paloOpenVPN->stopServiceOpenVPN())
	   {
	    	$smarty->assign("mb_title", $arrLang["Stop Error"]);
    		$smarty->assign("mb_message", $paloOpenVPN->errMsg);
	   }

    }
    if(getParameter('download'))
    {
	switch (getParameter('download'))
	{
	    case 'logs':
	        if($paloOpenVPN->downloadLogs())
		{
	    	    $log_file='/tmp/openvpn_server_logs.zip';
	    	    if(file_exists($log_file) && is_readable($log_file))
	    	    {
	    	        header('Content-type: application/zip');
	    	        header('Content-Disposition: attachment; filename="openvpn_server_logs.zip"');
	    	        readfile($log_file);
	    	        exit;
	    	    }
	    	    else
	    	    {
	    		$smarty->assign("mb_title", $arrLang["Download Logs"]);
	    	        $smarty->assign("mb_message", $arrLang["Error downloading log files"]);
	    	    }
		}       
	    						    								
		break;
	    case 'config':
		if(getParameter('name'))
		{
		    $pNet_cfg = $pNet->obtener_configuracion_red();
		    header("Content-Description: File Transfer");
		    header("Content-type: application/txt");
		    header("Content-Disposition: attachment; filename=".$pNet_cfg['host']."_".getParameter('name').".ovpn");
		    echo $paloOpenVPN->generateConfigOpenVPN(getParameter('name'));
		    exit;
		}
		break;
	    case 'mail':
		if(getParameter('name'))
		{
		    $paloOpenVPN->sendConfigOpenVPN(getParameter('name'));
		    $smarty->assign("mb_title", $arrLang["Send Mail"]);
    		    $smarty->assign("mb_message", $arrLang["Email successfully sent to user "].getParameter('name'));
		}

		break;
	}
    }
    if(getParameter('start')) {
	   if(!$paloOpenVPN->startServiceOpenVPN())
	   {
	    	$smarty->assign("mb_title", $arrLang["Start Error"]);
    		$smarty->assign("mb_message", $arrLang[$paloOpenVPN->errMsg]);
	   }
	   
    }
    if(getParameter('submit_eliminar')=='Delete User')
    {
	   $paloOpenVPN->removeFromOpenVPN(getParameter('client'));
    }
    
    if(getParameter('mailtouser'))
    {
	if(count(getParameter('client'))>0)
	    foreach(getParameter('client') as $client)
		$paloOpenVPN->sendConfigOpenVPN($client);
    }

    if(getParameter('disconnectuser'))
    {
	if(count(getParameter('client'))>0)
	{
	    $disclients = "";
	    foreach(getParameter('client') as $client)
	    {
	        $disclients.=$client.",";
	        $paloOpenVPN->disconnectUser($client);
	    }
	    $smarty->assign("mb_title", $arrLang["Disconnect successfully"]);
	    $smarty->assign("mb_message",trim($disclients,",") );
	}
    }


    if( getParameter('filter') ){    
        if($oFilterForm->validateForm($_POST)) {
            // Exito, puedo procesar los datos ahora.
            $arrFilterExtraVars=array('filter_common_name'=>$filter_common_name,'filter_email'=>$filter_email,'filter_real_ip'=>$filter_real_ip,'filter_virtual_ip'=>$filter_virtual_ip);
        } else {
            // Error
            $smarty->assign("mb_title", $arrLang["Validation Error"]);
            $arrErrores=$oFilterForm->arrErroresValidacion;
            $strErrorMsg = "<b>{$arrLang['The following fields contain errors']}:</b><br>";
            foreach($arrErrores as $k=>$v) {
                $strErrorMsg .= "$k, ";
            }
            $strErrorMsg .= "";
            $smarty->assign("mb_message", $strErrorMsg);
        }
        $htmlFilter = $oFilterForm->fetchForm("$local_templates_dir/filter.tpl", "", $_POST);
    } else if (isset($filter_common_name) || isset($filter_email) || isset($filter_real_ip) || isset($filter_virtual_ip)) {
        $htmlFilter = $oFilterForm->fetchForm("$local_templates_dir/filter.tpl", "", $_GET);
       $arrFilterExtraVars=array('filter_common_name'=>$filter_common_name,'filter_email'=>$filter_email,'filter_real_ip'=>$filter_real_ip,'filter_virtual_ip'=>$filter_virtual_ip);
    } else {
        $htmlFilter = $oFilterForm->fetchForm("$local_templates_dir/filter.tpl", "", $_POST);
    } 

    if (file_exists($lic_file)) 
        $smarty->assign("lic_status", $arrLang["Uploaded"]);
    else 
        $smarty->assign("lic_status", $arrLang["Not Uploaded"]);
    
    if(empty($arrValues)) $arrValues=$paloOpenVPN->loadSettings();
	
//	($arrValues['vsftpdsecure']=='on' ? $smarty->assign("vsftpdchecked", "checked") : '');
    
    if($paloOpenVPN->getStatusServiceOpenVPN()=="active") { 
	   $smarty->assign("SERVICE_STARING", true);
	   $smarty->assign("Status_openvpn", "<b><font color='#00AA00'>".$arrLang["Active"]."</font></b>");
    }
    else {
	   $smarty->assign("SERVICE_STARING", false);
	   $smarty->assign("Status_openvpn", "<b><font color='#FF0000'>".$arrLang["Inactive"]."</font></b>");
    }

    if($paloOpenVPN->checkLic()!=0)
    {
	$smarty->assign("Status_trial", "<b><font color='red'>".$arrLang["Unregistered Version"]."</font></b>");
	$smarty->assign("TRIAL_LIMIT", "<a href=#><img height=15px src=/modules/openvpn_server/images/alert.png title='".$arrLang["Trial Limit"]."' alt='".$arrLang["Trial Limit"]."'/></a>");
    }

    //Check Installation package OpenVPN
    if(!$paloOpenVPN->checkInstall('openvpn'))
    {
	$smarty->assign("mb_title", $arrLang["Installation Error"]);
        $smarty->assign("mb_message", $arrLang["OpenVPN Not Installed"]);
    }

    if(!$paloOpenVPN->checkTables())
    {
	$smarty->assign("mb_title", $arrLang["Error"]);
        $smarty->assign("mb_message", $arrLang["NAT Error"]);
    }

    $smarty->assign("REQUIRED_FIELD", $arrLang["Required field"]);
    $smarty->assign("RUN", $arrLang["Update"]);
    $smarty->assign("SERVICE_CFG", $arrLang["Re/Create Server Config"]);
    $smarty->assign("MAIL_CFG", $arrLang["Mail Template"]);
    $smarty->assign("SERVICE_START", $arrLang["Service Start"]);
    $smarty->assign("SERVICE_STOP", $arrLang["Service Stop"]);
    $smarty->assign("DELETE", $arrLang["Delete User"]);
    $smarty->assign("Status", $arrLang["Status"]);
    $smarty->assign("SECUREWEB",$arrLang["Secure web"]);
    $smarty->assign("SECUREASTERISK",$arrLang["Secure asterisk"]);
    $smarty->assign("SECURESSH",$arrLang["Secure ssh"]);
    $smarty->assign("SECUREPROFTPD",$arrLang["Secure proftpd"]);
    $smarty->assign("SECUREVSFTPD",$arrLang["Secure vsftpd"]);
    $smarty->assign("SECURITY", $arrLang["Improved security"]);
    $smarty->assign("TURN_ON", $arrLang["Turn on"]);
    $smarty->assign("SECURITY", $arrLang["Security settings"]);
    $smarty->assign("BLOCKED", $arrLang["Blocked IP addresses"]);

    $smarty->assign("module_name",$module_name);
    $smarty->assign("seconds",$arrLang["Seconds"]);

    $arrData=$paloOpenVPN->load_openvpn_table($filter_common_name,$filter_email,$filter_real_ip,$filter_virtual_ip);
    
    $total = count($arrData);
    
    $oGrid = new paloSantoGrid($smarty); 
 
    $action = getParameter("nav");
    $start  = getParameter("start");

    $url = array('menu' => $module_name); 
    if(isset($arrFilterExtraVars) && is_array($arrFilterExtraVars) and count($arrFilterExtraVars)>0) {
       $url = array_merge($url, $arrFilterExtraVars); 
    }

    if($oGrid->isExportAction()){
        $limit = $total;
        $offset = 0;
        $arrColumns = array(_tr("Common Name"),_tr("EMail"),_tr("Virtual Address"),_tr("Real Address"),_tr("Bytes Received"),_tr("Bytes Sent"),_tr("Connected Since"),_tr("Expire Date"));
      
        $oGrid->setColumns($arrColumns);
        $size = count($arrData);
        if(is_array($arrData) && $total>0)
        {
            foreach ($arrData as $key=>$val) 
                $tmpArrData[$key]=array(strip_tags($val[1]),strip_tags($val[2]),strip_tags($val[3]),strip_tags($val[4]),strip_tags($val[5]),strip_tags($val[6]),strip_tags($val[7]),strip_tags($val[8])); 
            $arrTableData=$oGrid->setData($tmpArrData);
        }
        
        return $oGrid->fetchGrid();
    }  
    else
    {  
        $limit = 20;
        $oGrid->setLimit($limit);
    	$oGrid->setTotal($total);
       
    	$offset = $oGrid->calculateOffset();
    	$end    = ($offset+$limit)<=$total ? $offset+$limit : $total;
    	
        $arrTableData=array_slice($arrData, $offset, $limit);
	
    }
    $k=0;
    $arrGrid = array("title"    => $arrLang["OpenVPN Clients List"],
                     "icon"     => "modules/openvpn_server/images/openvpn_logo.png",
                     "width"    => "99%",
                     "start"    => ($total==0) ? 0 : $offset+1,
                     "end"      => $end,
                     "url"      => $url,
                     "total"    => $total,
                     "columns"  => array($k++ => array("name"  => "",
                                                    "property"  => "width=25%"),
		                         $k++ => array("name"  => $arrLang["Common Name"],
                                                    "property"  => "width=25%"),
		                         $k++ => array("name"  => $arrLang["Email"],
                                                    "property"  => "width=25%"),
                                         $k++ => array("name"  => $arrLang["Virtual Address"],
                                                    "property"  => "width=20%"),
                                    	 $k++ => array("name"  => $arrLang["Real Address"],
                                                    "property"  => "width=20%"),
                                         $k++ => array("name"  => $arrLang["Bytes Received"],
                                                    "property"  => "width=20%"),
                                         $k++ => array("name"  => $arrLang["Bytes Sent"],
                                                    "property"  => "width=20%"),
                                         $k++ => array("name"  => $arrLang["Connected Since"],
                                                    "property"  => "width=20%"),
                                         $k++ => array("name"  => _("Expire Date"),
                                                    "property"  => "width=20%"),
                                         $k++ => array("name"  => $arrLang["Config"],
                                                    "property"  => "width=20%")
                                                    

    ));

    if(method_exists($oGrid,'customAction'))
        $oGrid->customAction("adduser", "Add User","/images/plus2.png");

    if(method_exists($oGrid,'customAction'))
        $oGrid->customAction("mailtouser", "Send Config","modules/openvpn_server/images/mail_btn.png");

    if(method_exists($oGrid,'customAction'))
        $oGrid->customAction("disconnectuser", "Disconnect","modules/openvpn_server/images/disconnect.png");


    if(method_exists($oGrid,'deleteList'))
        $oGrid->deleteList(_tr("delete User Configuration"),"submit_eliminar",_tr("Delete User")); 

    //BEGIN Filter Form
    if(method_exists($oGrid,'showFilter'))
	$oGrid->showFilter($htmlFilter);    
    if(method_exists($oGrid,'addFilterControl'))
    {
	if(isset($arrFilterExtraVars['filter_common_name']))
	    $oGrid->addFilterControl('Filter applied: Common Name = '.$arrFilterExtraVars['filter_common_name'],$arrFilterExtraVars,array('filter_common_name'=>''),false);
	if(isset($arrFilterExtraVars['filter_email']))
	    $oGrid->addFilterControl('Filter applied: Email = '.$arrFilterExtraVars['filter_email'],$arrFilterExtraVars,array('filter_email'=>''),false);
	if(isset($arrFilterExtraVars['filter_real_ip']))
	    $oGrid->addFilterControl('Filter applied: Real Address = '.$arrFilterExtraVars['filter_real_ip'],$arrFilterExtraVars['filter_real_ip'],array('filter_real_ip'=>''),false);
	if(isset($arrFilterExtraVars['filter_virtual_ip']))
	    $oGrid->addFilterControl('Filter applied: Virtual Address = '.$arrFilterExtraVars['filter_virtual_ip'],$arrFilterExtraVars,array('filter_virtual_ip'=>''),false);

    }
    //END Filter Form
    $oGrid->enableExport();   // enable export.
    //$oGrid->setNameFile_Export(_tr("BlockedIP"));

    $htmlGrid = $oGrid->fetchGrid($arrGrid, $arrTableData, $arrLang);
    $smarty->assign("IPTABLE",$htmlGrid);
    $smarty->assign("icon",'modules/openvpn_server/images/openvpn_logo.png');

    $strReturn = $oForm->fetchForm("$local_templates_dir/openvpn.tpl", $arrLang["OpenVPN Server"], $arrValues);
    
    return $strReturn;    
}

function createFilterForm($arrLang)
{
    
    $arrayFields = array(
        "filter_common_name"   => array( "LABEL"	 => $arrLang["Common Name"],
                                "REQUIRED"      	 => "no",
                                "INPUT_TYPE"    	 => "TEXT",
                                "VALIDATION_TYPE"        => "",
				"INPUT_EXTRA_PARAM"	 => "",
                                "VALIDATION_EXTRA_PARAM" => ""),

        "filter_email"   => array( "LABEL"		 => $arrLang["Email"],
                                "REQUIRED"      	 => "no",
                                "INPUT_TYPE"    	 => "TEXT",
                                "VALIDATION_TYPE"        => "",
				"INPUT_EXTRA_PARAM"	 => "",
                                "VALIDATION_EXTRA_PARAM" => ""),
                         
        "filter_real_ip" => array( "LABEL"               => $arrLang["Real IP"],
                                "REQUIRED"               => "no",
                                "INPUT_TYPE"             => "TEXT",
                                "INPUT_EXTRA_PARAM"      => "",
                                "VALIDATION_TYPE"        => "ip",
                                "VALIDATION_EXTRA_PARAM" => ""),
                                
        "filter_virtual_ip" => array( "LABEL"            => $arrLang["Virtual IP"],
                                "REQUIRED"               => "no",
                                "INPUT_TYPE"             => "TEXT",
                                "INPUT_EXTRA_PARAM"      => "",
                                "VALIDATION_TYPE"        => "ip",
                                "VALIDATION_EXTRA_PARAM" => ""),

    );
    return $arrayFields;
}
function createNewUserForm($arrLang,$paloOpenVPN)
{

    $arrayFields = array(
        "common_name"   => array("LABEL"		 => $arrLang["Common name"],
                                 "REQUIRED"      	 => "yes",
                                 "INPUT_TYPE"    	 => "TEXT",
                                 "VALIDATION_TYPE"       => "",
		                 "INPUT_EXTRA_PARAM"	 => array("SIZE" => "25"),
                                 "VALIDATION_EXTRA_PARAM" => ""),

	"static_ip"   	=> array("LABEL"                 => $arrLang["Static IP"],
                                "REQUIRED"               => "no",
                                "INPUT_TYPE"             => "SELECT",
                                "VALIDATION_TYPE"        => "",
				"INPUT_EXTRA_PARAM"	 => $paloOpenVPN->getStaticIpListOpenVPN(),
                                "VALIDATION_EXTRA_PARAM" => ""),
                         

        "province" => array( 	"LABEL"                  => $arrLang["Province"],
                                "REQUIRED"               => "yes",
                                "INPUT_TYPE"             => "TEXT",
                                "INPUT_EXTRA_PARAM"      => array("SIZE" => "25","readonly" => "true"),
                                "VALIDATION_TYPE"        => "",
                                "VALIDATION_EXTRA_PARAM" => ""),


        "city" => array( "LABEL"                  => $arrLang["City"],
                                "REQUIRED"               => "yes",
                                "INPUT_TYPE"             => "TEXT",
                                "INPUT_EXTRA_PARAM"      => array("SIZE" => "25","readonly" => "true"),
                                "VALIDATION_TYPE"        => "",
                                "VALIDATION_EXTRA_PARAM" => ""),

        "country" => array( "LABEL"                  => $arrLang["Country"],
                                "REQUIRED"               => "yes",
                                "INPUT_TYPE"             => "TEXT",
                                "INPUT_EXTRA_PARAM"      => array("SIZE" => "25","readonly" => "true"),
                                "VALIDATION_TYPE"        => "",
                                "VALIDATION_EXTRA_PARAM" => ""),

        "organization" => array( "LABEL"                  => $arrLang["Organization"],
                                "REQUIRED"               => "yes",
                                "INPUT_TYPE"             => "TEXT",
                                "INPUT_EXTRA_PARAM"      => array("SIZE" => "25","readonly" => "true"),
                                "VALIDATION_TYPE"        => "",
                                "VALIDATION_EXTRA_PARAM" => ""),


        "email" => array( "LABEL"                  => $arrLang["Email"],
                                "REQUIRED"               => "yes",
                                "INPUT_TYPE"             => "TEXT",
                                "INPUT_EXTRA_PARAM"      => array("SIZE" => "25"),
                                "VALIDATION_TYPE"        => "email",
                                "VALIDATION_EXTRA_PARAM" => ""),


        "cn" => array( "LABEL"                  => $arrLang["Canonical name"],
                                "REQUIRED"               => "yes",
                                "INPUT_TYPE"             => "TEXT",
                                "INPUT_EXTRA_PARAM"      => array("SIZE" => "25","readonly" => "true"),
                                "VALIDATION_TYPE"        => "",
                                "VALIDATION_EXTRA_PARAM" => ""),
        "expdate" => array( "LABEL"                  => _("Expiration Date"),
                                "REQUIRED"               => "yes",
                                "INPUT_TYPE"             => "DATE",
				"INPUT_EXTRA_PARAM"      => array( "FIRSTDAY" => 1, "FORMAT" => "%d.%m.%Y"),
                                "VALIDATION_TYPE"        => "ereg",
                                "VALIDATION_EXTRA_PARAM" => "([0-9]{1,2}).([0-9]{1,2}).([0-9]{4})"),
                                

    );
    return $arrayFields;
}

function createEditUserForm($arrLang,$paloOpenVPN,$common_name)
{

    $arrayFields = array(
        "common_name"   => array("LABEL"		 => $arrLang["Common name"],
                                 "REQUIRED"      	 => "yes",
                                 "EDITABLE" 	         => "no",
                                 "INPUT_TYPE"    	 => "TEXT",
		                 "INPUT_EXTRA_PARAM"	 => array("SIZE" => "25","readonly" => "true"),
                                 ),
                                

	"static_ip"   	=> array("LABEL"                 => $arrLang["Static IP"],
                                "REQUIRED"               => "no",
                                "INPUT_TYPE"             => "SELECT",
				"INPUT_EXTRA_PARAM"	 => $paloOpenVPN->getStaticIpListOpenVPN(NULL,$common_name),
                                "VALIDATION_EXTRA_PARAM" => ""),
                         
    );
    return $arrayFields;
}

function createNewServerForm($arrLang,$paloOpenVPN)
{
    $arrayFields = array(
        "province" => array( 	"LABEL"                  => $arrLang["Province"],
                                "REQUIRED"               => "yes",
                                "INPUT_TYPE"             => "TEXT",
                                "INPUT_EXTRA_PARAM"      => "",
                                "VALIDATION_TYPE"        => "",
                                "VALIDATION_EXTRA_PARAM" => ""),


        "city" => array( "LABEL"                  => $arrLang["City"],
                                "REQUIRED"               => "yes",
                                "INPUT_TYPE"             => "TEXT",
                                "INPUT_EXTRA_PARAM"      => "",
                                "VALIDATION_TYPE"        => "",
                                "VALIDATION_EXTRA_PARAM" => ""),

        "country" => array( "LABEL"                  => $arrLang["Country"],
                                "REQUIRED"               => "yes",
                                "INPUT_TYPE"             => "SELECT",
                                "INPUT_EXTRA_PARAM"      => $paloOpenVPN->getCountryListOpenVPN(),
                                "VALIDATION_TYPE"        => "",
                                "VALIDATION_EXTRA_PARAM" => ""),

        "organization" => array( "LABEL"                  => $arrLang["Organization"],
                                "REQUIRED"               => "yes",
                                "INPUT_TYPE"             => "TEXT",
                                "INPUT_EXTRA_PARAM"      => "",
                                "VALIDATION_TYPE"        => "",
                                "VALIDATION_EXTRA_PARAM" => ""),


        "email" => array( "LABEL"                  => $arrLang["Email"],
                                "REQUIRED"               => "yes",
                                "INPUT_TYPE"             => "TEXT",
                                "INPUT_EXTRA_PARAM"      => "",
                                "VALIDATION_TYPE"        => "email",
                                "VALIDATION_EXTRA_PARAM" => ""),


        "cn" => array( "LABEL"                  => $arrLang["Canonical name"],
                                "REQUIRED"               => "yes",
                                "INPUT_TYPE"             => "TEXT",
                                "INPUT_EXTRA_PARAM"      => "",
                                "VALIDATION_TYPE"        => "",
                                "VALIDATION_EXTRA_PARAM" => ""),
    );
    return $arrayFields;
}

function createMailTemplateForm($arrLang)
{
    $arrayFields = array(
        "realname" => array( 	"LABEL"                  => $arrLang["Real Name"],
                                "REQUIRED"               => "yes",
                                "INPUT_TYPE"             => "TEXT",
                                "INPUT_EXTRA_PARAM"      => array("style" => "width:580px")),
        "from_mail" => array( 	"LABEL"                  => $arrLang["From"],
                                "REQUIRED"               => "yes",
                                "INPUT_TYPE"             => "TEXT",
                                "VALIDATION_TYPE"        => "email",
                                "INPUT_EXTRA_PARAM"      => array("style" => "width:580px")),
        "subject" => array( 	"LABEL"                  => $arrLang["Subject"],
                                "REQUIRED"               => "yes",
                                "INPUT_TYPE"             => "TEXT",
                                "INPUT_EXTRA_PARAM"      => array("style" => "width:580px")),
        "body" => array( 	"LABEL"                  => $arrLang["Body"],
                                "REQUIRED"               => "yes",
                                "INPUT_TYPE"             => "TEXTAREA",
                                "INPUT_EXTRA_PARAM"      => "",
                                "COLS"			 => "70",
                                "ROWS"			 => "10",
                                "VALIDATION_TYPE"        => "",
                                "VALIDATION_EXTRA_PARAM" => ""),

    );
    return $arrayFields;
}


?>
